"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.openUrl = void 0;
const effect_1 = require("effect");
const types_1 = require("./types");
const ShellCommand = __importStar(require("@effect/platform/Command"));
const openUrl = (url) => effect_1.Effect.gen(function* ($) {
    const platform = yield* $(getPlatform());
    if (platform === 'linux') {
        return yield* $(xdgOpen(url));
    }
    // TODO: add support for opening urls on other platforms
    return yield* $(effect_1.Effect.fail((0, types_1.UsageError)({
        message: `Opening urls on ${platform} is not yet supported.`,
    })));
});
exports.openUrl = openUrl;
const getPlatform = () => effect_1.Effect.succeed(process.platform);
const xdgOpen = (url) => (0, effect_1.pipe)(ShellCommand.make('xdg-open', url), ShellCommand.exitCode, effect_1.Effect.mapError(() => (0, types_1.UsageError)({ message: 'Browser could not be opened.' })), effect_1.Effect.map(() => void 0));
